import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap
from random import randint

exercise = 'src.create_tuple'
function = 'create_tuple'

@points('1.create_tuple')
class CreateTupleTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.create_tuple import create_tuple
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter create_tuple(x: int, y: int, z: int)' )
        try:
            from src.create_tuple import create_tuple
            create_tuple(1,2,3)
        except:
            self.assertTrue(False, 'Se till att den funktionen kan anropas som:\ncreate_tuple(1,2,3)' )

    def test_2_type_of_return_value(self):
        create_tuple = load(exercise, function, 'en')
        val = create_tuple(1,2,3)
        self.assertTrue(type(val) == tuple, f'Funktionen {function} returnerar inte tuple när create_tuple(1,2,3) anropas.')
    
    def test_3_tuples(self):
        test_cases = ((1,4,2), (10, 8, 5), (100, 101, 102), (-10, -11, -12), (55, 550, 5500))
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                create_tuple = load(exercise, function, 'en')
                
                correct = (min(test_case), max(test_case), sum(test_case))
                
                try:
                    test_result = create_tuple(test_case[0], test_case[1], test_case[2])
                except:
                    self.assertTrue(False, f"Se till att den funktionen fungerar med parametrar {test_case}")

                self.assertEqual(correct, test_result, f"Resultatet '{test_result}' matchar inte modelllösningen '{correct}' när parametrarna är {test_case}")
                
              
if __name__ == '__main__':
    unittest.main()